#!/usr/bin/perl
#################################################
# multiadd.pl
#
# (C) Arbeitskreis Linux,
# siehe copyright.txt im Hauptordner
#
# WT_VK.4.10.20030811-AV.4.00.00000000

require '../../config.pl';
require '../../formdata.pl';
require '../../userdata.pl';
require '../../output.pl';

print $http_header;
print html_header("Liste von Benutzern anlegen");

$USERNAME = $ENV{'REMOTE_USER'};
@USERDATA = getuserdata($USERNAME);
%MAFORMDATA = hashFormData($ENV{'QUERY_STRING'});

if (!getauth($USERDATA[7])) {
  print html_webtoolserror("Liste von Benutzern anlegen","Zugang verweigert",1,"","",1);
  exit;
}

# Benutzerliste in ein Array packen ...
$DATANUMMER = 0;
$DATASTRNAME = sprintf "name%d", $DATANUMMER;
while ($MAFORMDATA{$DATASTRNAME} ne "") {
  $PERSONENLISTE[$DATANUMMER] = $MAFORMDATA{$DATASTRNAME};
  $DATANUMMER++;
  $DATASTRNAME = sprintf "name%d", $DATANUMMER;
}
$PERSONENANZAHL = $DATANUMMER;

# Wurde Accounts erstellen geklickt? Dann ...
if ($MAFORMDATA{'exec'} ne "") {
  if ($MAFORMDATA{'abteilung'} eq "") {
    print html_webtoolserror("Liste von Benutzern anlegen","Sie haben keine Abteilung eingegeben. Klicken Sie auf Zur&uuml;ck/Back, um die Daten zu vervollst&auml;ndigen.",1,"shuserlist.cgi","Benutzerliste",1);
    exit;
  }
  print html_webtoolsheader("#ffff00","Liste anlegen<br><A href=\"shuser.cgi\">Benutzerverwaltung</A><br><A href=\"../index.cgi\">Hauptmen&uuml;</A>",$webtools_version,get_hilfeurl());
  print "<H1>Acounts wurden erstellt.</H1>\n";
  for ($ZAEHLER=0; $ZAEHLER<$PERSONENANZAHL; $ZAEHLER++) {
    @TESTarr = split /\ /, $PERSONENLISTE[$ZAEHLER];
    if ($TESTarr[1] eq "") {
      print "Fehler Person $PERSONENLISTE[$ZAEHLER] wurde nicht hinzugefgt<BR>\n";
    } else {
      undef @userarr;
      $userarr[0] = $PERSONENLISTE[$ZAEHLER];
      $userarr[4] = $SAGRUPPENNAMEN[2];
      $CLID = getclassid($MAFORMDATA{'abteilung'});
      $USERLNAME = getlname($USERNAME);
      $userarr[6] = $NEWUSER_SHELL;
      $userarr[7] = "$MAFORMDATA{'abteilung'};$CLID;$USERLNAME;$USERNAME";
      createnewuser(@userarr);
    }
  }
  print html_webtoolsbuttons("shuserlist.cgi","Benutzerliste","../index.cgi","Hauptmen&uuml;");
  print html_extfooter(getfullver());
  exit;
}

# Wurde eine lschen Schaltflche geklickt ? Dann ...
for ($ZAEHLER=0; $ZAEHLER<$PERSONENANZAHL; $ZAEHLER++) {
  $DELDATASTR = sprintf "delname%d", $ZAEHLER;
  if ($MAFORMDATA{$DELDATASTR} ne "") {
    for ($ZAEHLER2=$ZAEHLER+1; $ZAEHLER2<$PERSONENANZAHL; $ZAEHLER2++) {
      $PERSONENLISTE[$ZAEHLER2-1] = $PERSONENLISTE[$ZAEHLER2];
    }
    $PERSONENANZAHL --;
  }
}

# Liste ausgeben ...
print html_webtoolsheader("#ffffff","Liste anlegen<br><A href=\"shuser.cgi\">Benutzerverwaltung</A><br><A href=\"../index.cgi\">Hauptmen&uuml;</A>",$webtools_version);
print "Mit dieser Seite k&ouml;nnen Sie eine ganze Abteilung auf einem Mal in das ";
print "System eingeben. Geben Sie immer den vollen Namen (Vorname Nachname) in das Namens-Feld ein. ";
print "Bitte vergessen Sie nicht die Abteilung.<BR><BR><FORM>Abteilung: <INPUT NAME=abteilung TYPE=text VALUE=\"$MAFORMDATA{'abteilung'}\"><p>";

for ($ZAEHLER=0; $ZAEHLER<$PERSONENANZAHL; $ZAEHLER++) {
  $DATASTRNAME = sprintf "name%d", $ZAEHLER;
  print "Name: <INPUT TYPE=text NAME=\"$DATASTRNAME\" VALUE=\"$PERSONENLISTE[$ZAEHLER]\"> <INPUT TYPE=submit NAME=\"del$DATASTRNAME\" VALUE=\"Person Lschen\"><BR>";
}

$DATASTRNAME = sprintf "name%d", $ZAEHLER;
print "Name:  <INPUT TYPE=text NAME=\"$DATASTRNAME\"> ";
print "<INPUT TYPE=submit NAME=\"add\" VALUE=\"Person in die Liste aufnehmen\"><BR>";
print "<INPUT TYPE=submit NAME=\"exec\" VALUE=\"Accounts erstellen\"><BR>";
print "</FORM></BODY>";
print html_extfooter(getfullver());
