#!/usr/bin/perl
#################################################
# shuserlist.pl
#
# (C) Arbeitskreis Linux,
# siehe copyright.txt im Hauptordner
#
# WT_VK.4.10.20030811-AV.4.00.00000000

# Bibliotheken fuer die Tools ...
require '../../config.pl';
require '../../userdata.pl';
require '../../formdata.pl';
require '../../output.pl';

# Benutzerdaten und Parameter auswerten ...
$USERNAME = $ENV{'REMOTE_USER'};
@USERDATA = getuserdata($USERNAME);
%FORMDATEN = hashFormData($ENV{'QUERY_STRING'});

# HTML-Kopf ausgeben ...
print $http_header;
print html_header("Benutzerverwaltung");

# Benutzerrecht pruefen ...
if (!getauth($USERDATA[7])) {
  print html_webtoolserror("Benutzerverwaltung","Zugang verweigert, Sie haben kein Recht die Benutzerdaten zu &auml;ndern.",1);
  exit;
}

# Alle Benutzer ermitteln
@users = getuserlist();

# HTML-Ausgabe ...
print html_webtoolsheader("#ffffff","<A href=\"shuser.cgi\">Benutzerverwaltung</A><br><A href=\"../index.cgi\">Hauptmen&uuml;</A>",$webtools_version,get_hilfeurl());
print "<H1>Benutzerverwaltung</H1>Klicken Sie auf eine der Schaltfl&auml;chen, oder w&auml;hlen Sie den Benutzername in der Liste unten aus, um dessen Daten zu&auml;ndern oder zu l&ouml;schen.<p>";
print html_webtoolsbuttons("../index.cgi","Hauptmen&uuml;","newuser.cgi","Benutzer anlegen");

# Weitere Daten der Benutzer ermitteln ...
foreach(@users) {
  ($dummy,$usernames{$_},$userclass{$_}) = getuserdata2($_);
}

# Sortierung ...
@sortliste = ("<FONT COLOR=#000000>Loginname</FONT>","<FONT COLOR=#000000>voller Name</FONT>","<FONT COLOR=#000000>Abteilung</FONT>");
if (($FORMDATEN{'sortorder'} eq "abteilung")||
    ($FORMDATEN{'sortorder'} eq "klasse")) {
  @users = sort {$userclass{$a} cmp $userclass{$b}} @users;
  $sortliste[2] = "<I>$sortliste[2]</I>";
} elsif (($FORMDATEN{'sortorder'} eq "fname")||
    ($FORMDATEN{'sortorder'} eq "vname")) {
  @users = sort {$usernames{$a} cmp $usernames{$b}} @users;
  $sortliste[1] = "<I>$sortliste[1]</I>";
} else {
  @users = sort @users;
  $sortliste[0] = "<I>$sortliste[0]</I>";
}

# Ausgabe der Benutzer ...
print "<P><TABLE BGCOLOR=#c0c0c0 BORDER=1><TR BGCOLOR=#ff00ff><TH><A HREF=\"shuserlist.cgi?sortorder=login\">$sortliste[0]</A></TH><TH><A HREF=\"shuserlist.cgi?sortorder=vname\">$sortliste[1]</A></TH><TH><A HREF=\"shuserlist.cgi?sortorder=abteilung\">$sortliste[2]</A></TH></TR>";
foreach(@users) {
  if (($USERDATA[7] == 1)||(getlehrer($_) eq $USERNAME)) {
    print "<TR><TD><A HREF=\"shuserdata.cgi?username=$_\">$_</A></TD><TD>$usernames{$_}</TD><TD>$userclass{$_}</TD></TR>";
  }
}
# Fusszeile ausgeben ...
print "</TABLE>";
print html_extfooter(getfullver());
