#!/usr/bin/perl
#################################################
# index.pl
# Auf- und Abbau der Internet-Verbindung
#
# (C) Arbeitskreis Linux,
# siehe copyright.txt im Hauptordner
#
# WT_VK.4.10.20030811-AV.4.00.00000000

require '../../config.pl';
require '../../userdata.pl';
require '../../output.pl';
require '../../logging.pl';

$html_shuttle2 = sprintf $html_shuttle2, $WWWSAPFAD;

$USERNAME = $ENV{'REMOTE_USER'};
@USERDATA = getuserdata($USERNAME);
$query_string=  $ENV{"QUERY_STRING"};
($key, $command) = split (/=/, $query_string);

print $http_header;
print $html_header;

if (!getauth($USERDATA[7])) {
  print html_webtoolserror("Internet Start/Stop","Zugang verweigert",1,"","",1);
  exit;
}
else
{
  if (!$command) { 
    print html_webtoolsheader("#ffffff", "Internet Start/Stop<BR><A HREF=\"../index.cgi\">Hauptmen&uuml;</A>",$webtools_version,get_hilfeurl());
    $out= `/usr/bin/cinternet -i $INTERFACE --status | grep status`;
    $out =~ s/\s//g;
#    print $out;
    $status= (split(/:/, $out))[1];
#    print "xxx:$status yyy ".length($status);
    if ($status eq "CONNECTING") {
       print "$out<h3>Die Verbindung &uuml;ber $INTERFACE ist vorhanden</h3>";
    }
    elsif ($status eq "LURKING") {
       print "<h3>Die Verbindung &uuml;ber $INTERFACE ist erlaubt</h3>";
    } 
    elsif ($status eq "disconnected") {
       print "<h3>Die Verbindung &uuml;ber $INTERFACE ist momentan abgebaut</h3>";
    } 
    else {
      print "<h3>Zustand der Verbindung &uuml;ber $INTERFACE </h3><br>$out";
    }
    print "<HR>";
    print html_webtoolsbuttons("index.cgi?command=start","Internet Start","index.cgi?command=stop","Internet Stop","../index.cgi","Hauptmen&uuml;");
    print html_extfooter(getfullver());
  }
  elsif ($command eq "start") {
    print html_webtoolsheader("#ffffff", "<A HREF=\"index.cgi\">WinShuttle Start/Stop</A><BR><A HREF=\"../index.cgi\">Hauptmen&uuml;</A>");
    $datum=`/bin/date "+DATUM=%d.%m.%y:ZEIT=%H.%M.%S"`;
    $out= `/usr/sbin/cinternet -i $INTERFACE --start`;
    $out =~ s/\n/<br>/g;
    print "<pre>$out";
    print "Verbindung gestartet von: $USERDATA[0]: zum Zeitpunkt: $datum";
    if (logmode(2)) { webtools_log("Internetverbindung gestartet."); }
    print "<HR>";
    print html_webtoolsbuttons("index.cgi","Internet Start/Stop Men&uuml;","../index.cgi","Hauptmen&uuml;");
    print html_extfooter(getfullver());
  } 
  elsif ($command eq "stop") {
    print html_webtoolsheader("#ffffff", "<A HREF=\"index.cgi\">Internet Start/Stop</A><BR><A HREF=\"../index.cgi\">Hauptmen&uuml;</A>");
    $datum=`/bin/date "+DATUM=%d.%m.%y:ZEIT=%H.%M.%S"`;
    $out= `/usr/sbin/cinternet -i $INTERFACE --stop`;
    $out =~ s/\n/<br>/g;
    print "<pre>$out";
    print "Verbindung gestoppt von: $USERDATA[0]: zum Zeitpunkt: $datum";
    if (logmode(2)) { webtools_log("Internetverbindung gestoppt."); }
    print "<HR>";
    print html_webtoolsbuttons("index.cgi","Internet Start/Stop Men&uuml;","../index.cgi","Hauptmen&uuml;");
    print html_extfooter(getfullver());
  } 
}
