#!/usr/bin/perl
#################################################
# index.pl
# Eingangsseite zum Software-Update
# Es wird zuerst die Datei update.dat vom FTP-Server geladen
# Diese Datei wird mit der lokalen Datei update.lokal verglichen
# und alle neuen Updates eingespielt
#
# (C) Arbeitskreis Linux,
# siehe copyright.txt im Hauptordner
#
# WT_VK.4.10.20030811-AV.4.00.00000000

$mypath="/usr/local/httpd/htdocs/tools";


$http_header = "Content-type: text/html\n\n";

$html_header = "<HTML><HEAD><TITLE>Update</TITLE></HEAD>";

$html_noright = "<BODY BGCOLOR=#ff0000><H1>Zugang verweigert</H1><A HREF=\"../index.cgi\">Hauptmen&uuml;</A></BODY></HTML>";

$html_update1f = <<'EOF';
<hr><b>n&auml;chster Schritt: Laden von update.dat</b>
<hr><A HREF="index.cgi?command=schritt1">Weiter</a>
</BODY></HTML>
EOF

$html_update2f = <<'EOF';
<hr><b>n&auml;chster Schritt: Vergleich von update.dat und update.lokal</b>
<hr><A HREF="index.cgi?command=schritt2">Weiter</a>
</BODY></HTML>
EOF

$html_update3f = <<'EOF';
<hr><b>n&auml;chster Schritt: Laden der Updates nach /tmp (etwas Geduld bitte)</b>
<hr><A HREF="index.cgi?command=schritt3">Weiter</a>
</BODY></HTML>
EOF

$html_update4f = <<'EOF';
<hr><b>n&auml;chster Schritt: Entpacken der Archive</b>
<hr><A HREF="index.cgi?command=schritt4">Weiter</a>
</BODY></HTML>
EOF

$html_update5f = <<'EOF';
<hr><b>n&auml;chster Schritt: Ausf&uuml;hren der Dateien *.pl aus
 bin</b>
<hr><A HREF="index.cgi?command=schritt5">Weiter</a>
</BODY></HTML>
EOF

$html_update6f = <<'EOF';
<hr>Fertig<hr>
<A HREF="../index.cgi"><IMG SRC="../../images/main.gif" BORDER=0 ALT="Hauptmen&uuml;"></A>
</BODY></HTML>
EOF

$html_erkl = <<'EOF';
Beim Software-Update werden folgende Schritte ausgef&uuml;hrt:<br>
1. Laden der Datei update.dat ins aktuelle Verzeichnis<br>
2. Vergleich von update.dat mit update.lokal<br>
3. Alle Dateien, die in update.dat vorkommen, aber nicht in update.lokal, 
werden geholt und nach /tmp gespeichert.<br>
4. Die geladenen Archive werden ins Web-Tools Verzeichnis entpackt<br>
5. Falls im Wurzelverzeichnis des Archive eine Datei update.pl existiert
wird sie ausgef&uuml;hrt.<p>Jeder Schritt mu&szlig; einzeln best&auml;tigt
werden, erfolgt aber auf eigene Gefahr!<br>
EOF

require '../../config.pl';
require '../../userdata.pl';
require '../../output.pl';

$html_noright = sprintf $html_noright, $WWWSAPFAD;


$USERNAME = $ENV{'REMOTE_USER'};
@USERDATA = getuserdata($USERNAME);
$query_string=  $ENV{"QUERY_STRING"};
($key, $command) = split (/=/, $query_string);

print $http_header;
print $html_header;

if (!getauth($USERDATA[7])) {
  print $html_noright;
  exit;
}
else
{
  if (!$command) {
  print html_webtoolsheader("#ffffff", "Software Update<BR><A HREF=\"../index.cgi\">Hauptmen&uuml;</A>");
  print $html_erkl;   
  print $html_update1f;
  }
  elsif ($command eq "schritt1") {
    print html_webtoolsheader("#ffffff", "<A HREF=\"index.cgi\">Software Update</A><BR><A HREF=\"../index.cgi\">Hauptmen&uuml;</A>");
    print "<p>&nbsp;<H2>Schritt 1: Laden der Verzeichnisdatei</h2>";
    $out= `/bin/rm update.dat`;
    $out =~ s/\n/<br>/g;
    print $out;
  
    $out= `/usr/bin/wget -v ftp://ftp.debacher.net/pub/tools/update.dat`;
    $out =~ s/\n/<br>/g;
    print $out;
    print "</pre>";
    print $html_update2f;
  }
  elsif ($command eq "schritt2") {
    print html_webtoolsheader("#ffffff", "<A HREF=\"index.cgi\">Software Update</A><BR><A HREF=\"../index.cgi\">Hauptmen&uuml;</A>");
    print "<p>&nbsp;<H2>Schritt 2: Ermitteln der neuen Updates</h2>";
    open(ALT, "update.lokal");
    @azeilen=<ALT>;
    close (ALT);
    open(NEU, "update.dat");
    @nzeilen=<NEU>;
    close (NEU);
    $updates=0;
    @update=();
    open (WAS, ">/tmp/updates.hbs");
    foreach $nzeile (@nzeilen) 
    {
      $gefunden=0;
      foreach $azeile (@azeilen) 
      {
       if ($nzeile eq $azeile) {
         $gefunden=1;
       }
      }
      if ($gefunden eq 0) {
       if ($nzeile ne "") {
         print "$nzeile<br>";
         @update = (@update, $nzeile);
         $updates=1;       
         print WAS "$nzeile"; 
       }
      }
    }
    close (WAS);
    print "</pre>";
    print $html_update3f;
    }
  elsif ($command eq "schritt3") {
    print html_webtoolsheader("#ffffff", "<A HREF=\"index.cgi\">Software Update</A><BR><A HREF=\"../index.cgi\">Hauptmen&uuml;</A>");
    print "<p>&nbsp;<H2>Schritt 3: Laden der neuen Updates</h2>";
    open(NEU, "/tmp/updates.hbs");
    @azeilen=<NEU>;
    close (NEU);
    chdir "/tmp";
    foreach $zeile (@azeilen) 
    {
      $out= `/bin/rm $zeile`;
      $out =~ s/\n/<br>/g;
      print $out;
      $out= `/usr/bin/wget -v ftp://ftp.debacher.net/pub/tools/$zeile`;
      $out =~ s/\n/<br>/g;
      print $out;
    }
    print "</pre>";
    print $html_update4f;
    }
  elsif ($command eq "schritt4") {
    print html_webtoolsheader("#ffffff", "<A HREF=\"index.cgi\">Software Update</A><BR><A HREF=\"../index.cgi\">Hauptmen&uuml;</A>");
    print "<H2>Schritt 4: Auspacken der Archive</h2><pre>";
    open(NEU, "/tmp/updates.hbs");
    @azeilen=<NEU>;
    close (NEU);
    open (WAS, ">>update.lokal");
    chdir $mypath;
    foreach $zeile (@azeilen) 
    {
      print "<b>Archiv: /tmp/$zeile</b>";
      print WAS $zeile;
      $out= `/bin/tar xvfz /tmp/$zeile`;
      $out =~ s/\n/<br>/g;
      print "$out\n";
    }
    print "</pre>";
    close (WAS);
    print $html_update5f;
  }
  elsif ($command eq "schritt5") {
    print html_webtoolsheader("#ffffff", "<A HREF=\"index.cgi\">Software Update</A><BR><A HREF=\"../index.cgi\">Hauptmen&uuml;</A>");
    print "<H2>Schritt 5: Starten der Scripten</h2><pre>";
    @programme = <bin/*.pl>;
    foreach $zeile (@programme) {
      print "$zeile<br>";
      $out= `$zeile`;
      $out =~ s/\n/<br>/g;
      print "$out\n";
      $out= `/bin/rm $zeile`;
      $out =~ s/\n/<br>/g;
      print "$out\n";
    } 
    print $html_update6f;
  }
}

