#################################################
# formdata.pl
# Diese Datei aktualisiert das yfh.pwd - File
#
# (C) Arbeitskreis Linux,
# siehe copyright.txt im Hauptordner
#
# WT_VK.4.10.20030811-AV.4.00.00000000

####################
# Die Routine hashFormData gibt ein HASH Array mit dem Formdaten zurck.
# 
# Der Query_String wird als Parameter bergeben.
#

sub hashFormData {
  local ($QUERY_STR, %hashArr, @arr1, @arr2, $ZZaehl, $ZZeich, $Resu);
  $QUERY_STR = $_[0];
  
# Plus zu Leerzeichen wandeln ...
  $QUERY_STR =~ tr/+/ /;
# Extrazeichen zu Extrazeichen wandeln (umstndlich)
  $Resu = "";
  for($ZZaehl=0; $ZZaehl<length($QUERY_STR); $ZZaehl++) {
    if (substr($QUERY_STR,$ZZaehl,1) ne "%") {
      $Resu = sprintf "%s%s",$Resu,substr($QUERY_STR,$ZZaehl,1);
    } else {
      $Resu = sprintf "%s%s",$Resu,chr(hex(substr($QUERY_STR,$ZZaehl+1,2)));
      $ZZaehl = $ZZaehl+2;
    }
  }
  @arr1 = split(/&/,$Resu,-1);
  foreach (@arr1) {
    @arr2 = split(/=/,$_,-1);
    if (exists($hashArr{$arr2[0]})) {
      if ($hashArr{$arr2[0]} eq "") {
        $hashArr{$arr2[0]} = $arr2[1];
      } else {
        $hashArr{$arr2[0]} = "$hashArr{$arr2[0]},$arr2[1]";
      }
    } else {
      $hashArr{$arr2[0]} = $arr2[1];
    }
    undef(@arr2);
  }
  
  return %hashArr;
}

###########################################################
# Die Routine mkFormData wandelt Leerzeichen in Plus, Plus
# in %2b und % in %25 um.
# Das Ergebnis wird zurueckgegeben.
#
sub mkFormData {
  my $InString = $_[0];
  local($OutString,$Zeichen,$tmp);
  
  for ($tmp=0,$OutString=""; $tmp<=length($InString); $tmp++) {
    $Zeichen = substr($InString,$tmp,1);
    if ($Zeichen eq "\ ") {$OutString = "$OutString+";}
    elsif ($Zeichen eq "+") {$OutString = "$OutString%2b";}
    elsif ($Zeichen eq "%") {$OutString = "$OutString%25";}
    elsif ($Zeichen eq ".") {$OutString = "$OutString%2e";}
    else {$OutString = "$OutString$Zeichen";}
  }
  return $OutString;
}

1; # ???
