#/bin/sh
#########
# Erstellt von Markus Zuehlke.
#
# Erstellt die setroot(*.cgi) Dateien.
# jede ausfuehrbare .pl Datei bekommt eine .cgi Datei.
# Diese CGI-Datei ruft das .pl - Script mit UID = 0(root) auf.
# Dieser Quellcode darf beliebig veraendert werden.
# Die Kopierrechte liegen bei dem Arbeitskreis Linux.
# Es wird keine Haftung fuer entstehende Schaeden genommen.
#

#declare plscripte
#declate plfile
echo "makecgi - erstellt die .cgi Dateien."
echo
echo "Grundlage ist die Datei source/setroot.c"
echo "Alle bestehenden .cgi Dateien werden uebergeschrieben."
echo
echo -n "Sind Sie sich sicher, dass Sie fortfahren moechten ? [J/Y/N] "
read res
case "$res" in
  j|J|y|Y)
    gcc  source/setroot2.c -DEXT_FILENAME='"'nichts/pwdupdate.pl'"' -o pwdupdate.cgi
    chmod u+s pwdupdate.cgi
    plscripte=`find admin | grep .pl`
    for plfile in $plscripte; do
      if [ -x $plfile ]; then
        echo Mache `echo -n $plfile|cut -d . -f 1`.cgi
        gcc source/setroot2.c -DEXT_FILENAME='"'$plfile'"' -o `echo -n $plfile|cut -d . -f 1`.cgi
        chmod u+s `echo -n $plfile|cut -d . -f 1`.cgi
      fi
    done
esac