#################################################
# miscfunc.pl
# Verschidene Funktionen ...
#
# (C) Arbeitskreis Linux,
# siehe copyright.txt im Hauptordner
#
# WT_VK.4.10.20030811-AV.4.00.00000000

# Array mit den Monatsangaben
@make_date_marr = ("Jan", "Feb", "Mar", "Apr", "Mai", "Jun",
	 	   "Jul", "Aug", "Sep", "Oct", "Nov", "Dez");

# make_time(seconds)
# Konvertiert eine Unix Zeit in die zugehoerige Uhrzeitangabe
sub make_time
{
local(@tm);
@tm = localtime($_[0]);
return sprintf "%2.2d:%2.2d", $tm[2], $tm[1];
}

# make_date(seconds)
# Konvertiert eine Unix Zeit in die zugehoerige Datumsangabe
sub make_date
{
local(@tm);
@tm = localtime($_[0]);
return sprintf "%2d.%s %4d", $tm[3], $make_date_marr[$tm[4]], $tm[5]+1900;
}

# ext_string gibt einen String mit aufgef|llten Leerzeichen am Ende
# mit einer vorgegebenen Gesamtlaenge zurueck. [0]=Parameter [1]=Geslaenge
sub ext_string {
  my $instr = $_[0];
  my $leng = $_[1];
  local ($outstr, $z);
  
  $outstr = "$instr";
  for ($z=length($instr); $z<=$leng; $z++) {$outstr = "$outstr ";}
  return $outstr;
}

1; # Jupp
