#!/usr/bin/perl
#################################################
# adduser.pl
#
# (C) Arbeitskreis Linux,
# siehe copyright.txt im Hauptordner
#
# WT_VK.4.10.20030811-AV.4.00.00000000

# Dieses Script erstellt einen neuen Benutzer
# Wenn nur der Volle Name gegeben ist ist username = ii1000
# Wenn nur der Benutzername gegeben ist, dann ist vollername = Benutzername
# Passwort = "" dann ist Passwort = Vorname oder username

$html_noright = "<BODY BGCOLOR=#ff4040><H1>Zugang verweigert</H1></BODY></HTML>";
$html_changed = "<BODY BGCOLOR=#ffffff><H1>Benutzerdaten werden angelegt</H1><A HREF=\"shuserlist.cgi\">Benutzerliste</A><BR><A HREF=\"../index.cgi\">Hauptmen&uuml;</A><BR><BR><B>Info:</B><BR></BODY></HTML>";

# ------------

require '../../config.pl';
require '../../userdata.pl';
require '../../formdata.pl';
require '../../output.pl';

# Formdaten abfragen
$FORMDATA = <STDIN>;
chomp $FORMDATA;
%UAFORMDATA = hashFormData($FORMDATA);

# Header schon mal ausgeben
print $http_header;
print html_header("Neuen Benutzer erstellen");

# Benutzerdaten pruefen
$USERNAME = $ENV{'REMOTE_USER'};
@USERDATA = getuserdata($USERNAME);
if (!getauth($USERDATA[7])) {
  print html_webtools("Neuen Benutzer erstellen","Zugang verweigert. Sie haben f&uuml;r diese Funktion keine ben&ouml;tigten Rechte",1,"","",1);
  exit;
}

# Benutzerdaten in eine Liste packen und erstellen.
$NUSERDATA[0] = $UAFORMDATA{'lname'};
$NUSERDATA[1] = $UAFORMDATA{'loginname'};
$NUSERDATA[2] = $UAFORMDATA{'passwd'};
$NUSERDATA[4] = $UAFORMDATA{'sagroup'};
$NUSERDATA[6] = $UAFORMDATA{'shell'};
$CLID = getclassid($UAFORMDATA{'klasse'});
$USERLNAME = getlname($USERNAME);
$NUSERDATA[7] = "$UAFORMDATA{'klasse'};$CLID;$USERLNAME;$USERNAME";
if ($UAFORMDATA{'klasse'} eq "") {
  print html_webtoolserror("Neuen Benutzer anlegen","Sie haben keine Abteilung angegeben.",1,"newuser.cgi","Noch einmal versuchen",1);
  exit;
}
if ($UAFORMDATA{'lname'} eq "") {
  print html_webtoolserror("Neuen Benutzer anlegen","Sie haben keinen Namen angegeben.",1,"newuser.cgi","Noch einmal versuchen",1);
  exit;
}
print html_webtoolsheader("#ffff00","Neuen Benutzer anlegen<br><A href=\"../index.cgi\">Hauptmen&uuml;</A>",$webtools_version);
print "<U>Ergebnis:</U><BR>";
createnewuser(@NUSERDATA);
print "<A HREF=\"../index.cgi\">Hauptmen&uuml;</A><BR><A HREF=\"shuserlist.cgi\">Benutzerliste</A>";
print html_extfooter(getfullver());
