#!/usr/bin/perl
#################################################
# deluser.pl
#
# (C) Arbeitskreis Linux,
# siehe copyright.txt im Hauptordner
#
# WT_VK.4.10.20030811-AV.4.00.00000000

# Dieses Script lscht einen Benutzer, wenn der 'exec' Parameter 'wirklich'
# ist. Sonst wird eine Warnseite ausgegeben.

# loginname, loginname, loginname
$html_warntext = <<'EOF';
<H1>Wollen Sie den Benutzer %s(%s) wirklich l&ouml;schen?</H1>
<FORM>
<INPUT TYPE="hidden" NAME="username" VALUE="%s">
<INPUT TYPE="hidden" NAME="exec" VALUE="wirklich">
<!--<INPUT TYPE=radio NAME="delhome" VALUE="ja" CHECKED> Home-Verzeichnis l&ouml;schen<BR>
<INPUT TYPE=radio NAME="delhome" VALUE="nein"> Home-Verzeichnis nicht l&ouml;schen<BR>!-->
EOF
# loginname

# Ende globale Defs

require '../../config.pl';
require '../../formdata.pl';
require '../../userdata.pl';
require '../../output.pl';

$USERNAME = $ENV{'REMOTE_USER'};
@USERDATA = getuserdata($USERNAME);

print $http_header;
print html_header("Benutzer l&ouml;schen");

if (!getauth($USERDATA[7])) {
  print html_webtoolserror("Benutzer l&ouml;schen","Zugang verweigert. F&uuml;r diese Funktion fehlt Ihnen das ben&ouml;tige Recht.",1,"","",1);
  exit;
}

%UDFORMDATA = hashFormData($ENV{'QUERY_STRING'});

$OUSERNAME = $UDFORMDATA{'username'};
@OUSERDATA = getuserdata($OUSERNAME);
# Wenn Lehrer und nicht eigener Schueler ...
if (($USERDATA[7]==2)&&($OUSERDATA[11] ne $USERNAME)) {
  print html_webtoolserror("Benutzer l&ouml;schen","Sie haben f&uuml;r diese Funktion kein Recht.",1,"","",1);
  exit;
}

if ($UDFORMDATA{'exec'} ne "wirklich") {
  print html_webtoolsheader("#ff4040","Benutzer l&ouml;schen<br><A href=\"shuser.cgi\">Benutzerverwaltung<br><A href=\"../index.cgi\">Hauptmen&uuml;</A>",$webtools_version);
  printf $html_warntext, $UDFORMDATA{'username'}, $OUSERDATA[2],$UDFORMDATA{'username'}, $UDFORMDATA{'username'};
  print html_webtoolsbuttons("__submit","Benutzer l&ouml;schen","shuserdata.cgi?username=$UDFORMDATA{'username'}","Benutzer nicht l&ouml;schen, zur&uuml;ck");
  print "</FORM>";
  print html_extfooter(getfullver());
  exit;
}

$HOMERMSTRING = "-r";

$DELUSERNAME = $UDFORMDATA{'username'};

$DELUSERNAME =~ s/[^a-zA-Z0-9\-\_]//g;

$res_str = `/usr/sbin/userdel $HOMERMSTRING $DELUSERNAME && echo ok`;
chomp $res_str;

$erg= system("/usr/bin/smbpasswd -x $DELUSERNAME >> /dev/null");

if ($res_str eq "ok") {
  printf html_webtoolsinfo("Benutzer gel&ouml;scht<br><A href=\"shuser.cgi\">Benutzerverwaltung<br><A href=\"../index.cgi\">Hauptmen&uuml;</A>","Der Benutzer $DELUSERNAME wurde gel&ouml;scht.",1,"shuserlist.cgi","Benutzerliste",1);
} else {
  print html_webtoolserror("Benutzer nicht gel&ouml;scht<br><A href=\"shuser.cgi\">Benutzerverwaltung<br><A href=\"../index.cgi\">Hauptmen&uuml;</A>","Beim l&ouml;schen des Benutzers trat ein Fehler auf.",1,"shuserlist.cgi","Benutzerliste",1);
}
