#!/usr/bin/perl
#################################################
# newuser.pl
# Formular zur Eingabe eines neuen Benutzers
#
# (C) Arbeitskreis Linux,
# siehe copyright.txt im Hauptordner
#
# WT_VK.4.10.20030811-AV.4.00.00000000

$html_text = <<'EOF';
<B>Info: </B>Bitte geben Sie mindestens den Namen und die Abteilung ein, der
Rest wir gegebenenfalls automatisch eingef&uuml;gt.
<FORM ACTION="adduser.cgi" METHOD=POST>
<TABLE WIDTH=100%>
<TR><TD>Abteilung</TD><TD><INPUT TYPE=text NAME=klasse></TD><TD></TD><TD>Name</TD><TD><INPUT TYPE=text NAME="lname"></TD></TR>
<TR><TD><HR></TD><TD><HR></TD><TD><HR></TD><TD><HR></TD><TD><HR></TD></TR>
<TR><TD>Login-Name</TD><TD><INPUT TYPE=text NAME=loginname></TD><TD></TD><TD>Shell</TD><TD><SELECT NAME="shell">%s</SELECT></TD></TR>
<TR><TD>Passwort</TD><TD><INPUT TYPE=password NAME="passwd"></TD><TD></TD><TD>WebTools-Gruppe</TD><TD><SELECT NAME="sagroup" MULTIPLE SIZE=2>%s</SELECT></TD></TR>
</TABLE>
EOF

# ---------

require '../../config.pl';
require '../../userdata.pl';
require '../../output.pl';

print $http_header;
print html_header("Neuen Benutzer anlegen");

$USERNAME = $ENV{'REMOTE_USER'};
@USERDATA = getuserdata($USERNAME);
if (!getauth($USERDATA[7])) {
  print html_webtoolserror("Neuen Benutzer anlegen","F&uuml;r diese Funktion haben Sie kein Recht.",1,"","",1);
  exit;
}

$html_text = sprintf $html_text, "", html_shells($NEWUSER_SHELL), html_saright("",$USERDATA[7]);

print html_webtoolsheader("#ffffff","Neuen Benutzer anlegen<br><A href=\"shuser.cgi\">Benutzerverwaltung</A><br><A href=\"../index.cgi\">Hauptmen&uuml;</A>",$webtools_version,get_hilfeurl());
#print "Shells: " . html_shells($NEWUSER_SHELL) ."<br>";
#print "Rechte: " . html_saright("",$USERDATA[7]) . "<br>";
print $html_text ;
print html_webtoolsbuttons("__submit","Benutzer anlegen","shuserlist.cgi","Benutzerliste","../index.cgi","Hauptmen&uuml;","__reset","Zur&uuml;ck setzen");
print "</FORM>";
print html_extfooter(getfullver());
