#!/usr/bin/perl
#################################################
# shuser.pl
# zeigt eine Benutzerliste an.
#
# (C) Arbeitskreis Linux,
# siehe copyright.txt im Hauptordner
#
# WT_VK.4.10.20030811-AV.4.00.00000000

# Bibliotheken fuer die WebTools ...
require '../../config.pl';
require '../../userdata.pl';
require '../../formdata.pl';
require '../../output.pl';

# Benutzerdaten und Parameter auswerten ...
$USERNAME = $ENV{'REMOTE_USER'};
@USERDATA = getuserdata($USERNAME);
%FORMDATEN = hashFormData($ENV{'QUERY_STRING'});

# HTML-Kopf ausgeben ...
print $http_header;
print html_header("Benutzerverwaltung");

# Benutzerrecht pruefen ...
if (!getauth($USERDATA[7])) {
  print html_webtoolserror("Benutzerverwaltung","Zugang verweigert, Sie haben kein Recht die Benutzerdaten zu &auml;ndern.",1);
  exit;
}

# Weitere Daten der Benutzer ermitteln ...
($dummy,$dummy,$usernames{$USERNAME},$dummy,$dummy,$dummy,$dummy,$dummy,$userclass{$USERNAME},$dummy,$dummy,$dummy) = getuserdata($USERNAME);

# HTML-Ausgabe ...
print html_webtoolsheader("#ffffff","Benutzerverwaltung<br><A href=\"../index.cgi\">Hauptmen&uuml;</a>",$webtools_version,get_hilfeurl());
print "<H1>Benutzerverwaltung</H1>Hallo $usernames{$USERNAME} bitte w&auml;hlen:<p>";
print html_webtoolsbuttons("../index.cgi","Hauptmen&uuml;","shuserlist.cgi", "Benutzerliste","newuser.cgi","Benutzer anlegen");

# Fusszeile ausgeben ...
print html_extfooter(getfullver());
