#!/usr/bin/perl 
#################################################
# shuserdata.pl
#
# (C) Arbeitskreis Linux,
# siehe copyright.txt im Hauptordner
#
# WT_VK.4.10.20030811-AV.4.00.00000000

# login, login, login, lang, home, shell, sa-Gruppe, login
$html_userform = <<'EOF';
<BODY BGCOLOR=#ffffff><H1>Benutzerdaten von %s</H1>
<FORM ACTION="chuserdata.cgi" METHOD=POST><INPUT TYPE=hidden NAME=username VALUE="%s">
<TABLE WIDTH=100%%>
<TR><TD>Login-Name</TD><TD><TT>%s</TT></TD><TD></TD><TD>Name</TD><TD><INPUT TYPE=text NAME="lname" VALUE="%s"></TD></TR>
<TR><TD>Home-Verzeichnis</TD><TD><!--<INPUT TYPE=text NAME="homedir" VALUE="!--><TT>%s</TT><!--">!--></TD><TD></TD><TD>Shell</TD><TD><SELECT NAME="shell">%s</SELECT></TD></TR>
<TR><TD>Passwort</TD><TD><INPUT TYPE=password
NAME="passwd"></TD><TD></TD><TD>Sekund&auml;re Gruppen</TD><TD rowspan=2><SELECT NAME=ogroups MULTIPLE SIZE=4>%s</SELECT></TD></TR>
<TR><TD>WebTools-Gruppen</TD><TD><SELECT NAME="sagroup" MULTIPLE SIZE=3>%s</SELECT></TD><TD></TD><TD></TD></TR>
<TR><TD>Abteilung</TD><TD><INPUT TYPE=text NAME="klasse" VALUE="%s"></TD><TD></TD><TD>Angelegt von</TD><TD><TT>%s</TT></TD></TR>
</TABLE><hr>
<B>Information: </B>In dem Feld Passwort steht kein Passwort, auch wenn es ein Passwort f&uuml;r
den Benutzer gibt. Wenn Sie das Passwort ndern wollen, dann geben Sie in das Feld das neue Passwort ein.
<!-- Buttonleiste !-->%s
</FORM>
EOF

# Ab hier bitte nichts mehr aendern ...

require '../../config.pl';   # Allgemeine Konfigs ...
require '../../formdata.pl'; # Zum schnellen auswerten der Formdaten.
require '../../userdata.pl'; # Zum ermitteln der Benutzerdaten
require '../../output.pl';

print $http_header;
print html_header("Benutzerdaten &auml;ndern");
$FORMDATEN = $ENV{'QUERY_STRING'};
$USERNAME = $ENV{'REMOTE_USER'};
# Formdaten in ein hash-array uebergeben
%HFORMDATEN = hashFormData($FORMDATEN);
@USERDATEN = getuserdata($USERNAME);
if (!getauth($USERDATEN[7])) {  # Nicht admin
  print html_webtoolserror("Benutzerdaten &auml;ndern","Zugriff verweigert, Sie haben kein ben&ouml;tigtes Recht.",1,"","",1);
  exit;
}
# Ist die Person Lehrer, dann pruefen ob auch eigener Schueler
if (($USERDATEN[7] == 2)&&(getlehrer($HFORMDATEN{'username'}) ne $USERNAME)) {
  print html_webtoolserror("Benutzerdaten &auml;ndern","Zugriff verweigert, Sie k&ouml;nnen nur die Daten Ihrer eigenen Sch&uuml;ler &auml;ndern.",1,"shuserlist.cgi","Benutzerliste",1);
  exit;
}
# Daten des zu ndernden Benutzers ermitteln ...
@OUSERDATA = getuserdata($HFORMDATEN{'username'});
if (@OUSERDATA == 0) {
  print html_webtoolserror("Benutzerdaten &auml;ndern","Benutzer existiert nicht.",1,"shuserlist.cgi","Benutzerliste",1);
  exit;
}
print html_webtoolsheader("#ffffff","Benutzerdaten &auml;ndern<br><A href=\"shuser.cgi\">Benutzerverwaltung</A><br><A href=\"../index.cgi\">Hauptmen&uuml;</A>",$webtools_version,get_hilfeurl());
# login, login, login, lang, home, shell, sa-Gruppe, andere Gruppen, login
printf $html_userform, $OUSERDATA[0],$OUSERDATA[0],$OUSERDATA[0],$OUSERDATA[2],$OUSERDATA[5],html_shells($OUSERDATA[6]),
#  html_allgroups($OUSERDATA[4],$USERNAME),
  html_groups($OUSERDATA[0],$USERNAME),
  html_saright($OUSERDATA[0],$USERDATEN[7]),
  $OUSERDATA[8],
  $OUSERDATA[10],
  html_webtoolsbuttons("__submit","Daten &auml;ndern","deluser.cgi?username=$OUSERDATA[0]","Benutzer l&ouml;schen","shuserlist.cgi","Benutzerliste","../index.cgi","Hauptmen&uuml;","__reset","Zur&uuml;ck setzten");

print html_extfooter(getfullver());

1;
