#!/usr/bin/perl
#################################################
# addgroup.pl
#
# (C) Arbeitskreis Linux,
# siehe copyright.txt im Hauptordner
#
# WT_VK.4.10.20030811-AV.4.00.00000000

# ------------

require '../../config.pl';
require '../../userdata.pl';
require '../../formdata.pl';
require '../../output.pl';

# Formdaten abfragen
$FORMDATA = $ENV{'QUERY_STRING'};
chomp $FORMDATA;
%GAFORMDATA = hashFormData($FORMDATA);

# Header schon mal ausgeben
print $http_header;
print html_header("Neue Gruppe anlegen");

# Benutzerdaten pruefen
$USERNAME = $ENV{'REMOTE_USER'};
@USERDATA = getuserdata($USERNAME);
if (!getauth($USERDATA[7])) {
  print html_webtoolserror("Neue Gruppe anlegen","Zugang verweigert, Sie k&ouml;nnen keine neue Gruppe anlegen.",1,"","",1);
  exit;
}

print html_webtoolsheader("#ffff00","Neue Gruppe anlegen",$webtools_version);
print "<U>Ergebnis:</U><BR>";

createnewgroup($GAFORMDATA{'grpname'});

print "<BR><A HREF=\"../index.cgi\">Hauptmen&uuml;</A><BR>";
print "<A HREF=\"shgrouplist.cgi\">Gruppenliste</A><BR>";

print html_extfooter(getfullver());
