#!/usr/bin/perl
#################################################
# delgroup.pl
#
# (C) Arbeitskreis Linux,
# siehe copyright.txt im Hauptordner
#
# WT_VK.4.10.20030811-AV.4.00.00000000

# grpname, grpname, grpname
$html_warntext = <<'EOF';
<H1>Wollen Sie die Gruppe %s wirklich l&ouml;schen?</H1>
<FORM>
<INPUT TYPE="hidden" NAME="groupname" VALUE="%s">
<INPUT TYPE="hidden" NAME="exec" VALUE="wirklich">
EOF
# groupname
$html_delinfo = <<'EOF';
<H1>Die Gruppe %s wurde gel&ouml;scht</H1>
<A HREF="shgrouplist.cgi">Benutzerliste</A><BR>
<A HREF="../index.cgi">Hauptmen&uuml;</A><BR>
</BODY></HTML>
EOF

# Ende globale Defs

require '../../config.pl';
require '../../formdata.pl';
require '../../userdata.pl';
require '../../output.pl';

$USERNAME = $ENV{'REMOTE_USER'};
@USERDATA = getuserdata($USERNAME);

print $http_header;
print html_header("Gruppe l&ouml;schen");

if (!getauth($USERDATA[7])) {
  print html_webtoolserror("Gruppe l&ouml;schen","Zugang verweigert",1,"","",1);
  exit;
}

%UDFORMDATA = hashFormData($ENV{'QUERY_STRING'});

if ($GRUPPENRECHT{$UDFORMDATA{'groupname'}}!=0) {
  print html_webtoolserror("Gruppe l&ouml;schen","Es handelt sich um eine WebTools-Gruppe, diese kann nicht gel&ouml;scht werden.",1,"shgrouplist.cgi","Gruppenliste",1);
  exit;
}

if ($UDFORMDATA{'exec'} ne "wirklich") {
  print html_webtoolsheader("#ff4040","Gruppe l&ouml;schen<br><A HREF=\"shgrouplist.cgi\">Gruppenverwaltung</A><br><A HREF=\"../index.cgi\">Hauptmen&uuml;</A>",$webtools_version);
  printf $html_warntext, $UDFORMDATA{'groupname'}, $UDFORMDATA{'groupname'};
  print html_webtoolsbuttons("__submit","Gruppe l&ouml;schen","shgroupdata.cgi?groupname=$UDFORMDATA{'groupname'}","Gruppe nicht l&ouml;schen, zur&uuml;ck","../index.cgi","Hauptmen&uuml;");
  print "</FORM>";
  print html_extfooter(getfullver());
  exit;
}

$DELGROUPNAME = $UDFORMDATA{'groupname'};

$TMPDELGROUPNAME = $DELGROUPNAME;
$DELGROUPNAME =~ s/[^a-zA-Z0-9\-\_]//g;

if ($TMPDELGROUPNAME ne $DELGROUPNAME) {
  print webtools_error("Gruppe l&ouml;schen","Der Gruppenname enth&auml;lt unsichere Zeichen, und wird deswegen nicht gel&ouml;scht",1,"shgrouplist.cgi","Gruppenliste",1);
  exit;
}

$res_str = `/usr/sbin/groupdel $DELGROUPNAME | echo ok`;

chomp $res_str;

if ($res_str eq "ok") {
  print html_webtoolsinfo("Gruppe l&ouml;schen<br><A HREF=\"shgrouplist.cgi\">Gruppenverwaltung</A><br><A HREF=\"../index.cgi\">Hauptmen&uuml;</A>","Die Gruppe $DELGROUPNAME wurde gel&ouml;scht.",1,"shgrouplist.cgi","Gruppenliste",1);
} else {
  print html_webtoolserror("Gruppe l&ouml;schen","Die Gruppe konnte nicht gel&ouml;scht werden!",1,"shgrouplist.cgi","Gruppenliste",1);
}
