#!/usr/bin/perl
#################################################
# shgroupdata.pl
#
# (C) Arbeitskreis Linux,
# siehe copyright.txt im Hauptordner
#
# WT_VK.4.10.20030811-AV.4.00.00000000

# grpname, Benutzer der Gruppe, grpname
$html_groupform = <<'EOF';
<H1>Gruppenname: <TT>%s</TT></H1>
<B>Informatin: </B>Wenn Sie einen Benutzer aus der Gruppe entfernen wollen,
dann klicken Sie den Benutzername unten an und ver&auml;ndern Sie die Daten
dort.
<BR>
<TABLE BORDER=1 WIDTH=100%%><TR><TD>
<U>Benutzer der Gruppe:</U><BR>
%s
</TD></TR></TABLE>
EOF
$html_unauth = <<'EOF';
<BODY TEXT=#ff4040>
<H1>Es ist Ihnen nicht gestattet die Daten zu &auml;dern</H1>
</BODY>
</HTML>
EOF

# Ab hier bitte nichts mehr aendern ...

require '../../config.pl';   # Allgemeine Konfigs ...
require '../../formdata.pl'; # Zum schnellen auswerten der Formdaten.
require '../../userdata.pl'; # Zum ermitteln der Benutzerdaten
require '../../output.pl';

print $http_header;
print html_header("Gruppenverwaltung");

$FORMDATEN = $ENV{'QUERY_STRING'};
$USERNAME = $ENV{'REMOTE_USER'};
# Formdaten in ein hash-array uebergeben
%HFORMDATEN = hashFormData($FORMDATEN);
@USERDATEN = getuserdata($USERNAME);
if (!getauth($USERDATEN[7])) {  # Nicht admin
  print html_webtoolserror("Gruppenverwaltung","Zugang verweigert.",1,"","",1);
  exit;
}

$GDATA = getuseringroup($HFORMDATEN{'groupname'});

print html_webtoolsheader("#ffffff","<A href=\"shgrouplist.cgi\">Gruppenverwaltung</A><br><A HREF=\"../index.cgi\">Hauptmen&uuml;</A>",$webtools_version);
print $html_header2;

printf $html_groupform,$HFORMDATEN{'groupname'},$GDATA;

print html_webtoolsbuttons("delgroup.cgi?groupname=$HFORMDATEN{'groupname'}","Gruppe l&ouml;schen","shgrouplist.cgi","Gruppenliste","../index.cgi","Hauptmen&uuml;");
print html_extfooter(getfullver());
