#!/usr/bin/perl
#################################################
# shgrouplist.pl
#
# (C) Arbeitskreis Linux,
# siehe copyright.txt im Hauptordner
#
# WT_VK.4.10.20030811-AV.4.00.00000000

require '../../config.pl';
require '../../userdata.pl';
require '../../output.pl';

$USERNAME = $ENV{'REMOTE_USER'};
@USERDATA = getuserdata($USERNAME);

print $http_header;
print html_header("Gruppenverwaltung");

if (!getauth($USERDATA[7])) {
  print html_webtoolserror("Gruppenverwaltung","Zugriff verweigert",1,"","",1);
  exit;
}

print html_webtoolsheader("#ffffff","Gruppenverwaltung<br><A HREF=\"../index.cgi\">Hauptmen&uuml;</A>",$webtools_version,get_hilfeurl());

@gruppen=();
setgrent;
while (@zeile=getgrent) {
 if (($zeile[2] > $FIRST_CH_GID) && ($zeile[2] < $LAST_CH_GID)) {
   push @gruppen, $zeile[0];
 }
}

print "<H1>Verwaltung von Gruppen</H1>Klicken Sie auf eine der Schaltfl&auml;chen, oder w&auml;hlen Sie den Gruppenname in der Liste unten aus, um deren Daten zu&auml;ndern oder zu l&ouml;schen.";
print html_webtoolsbuttons("../index.cgi","Hauptmen&uuml;","newgroup.cgi","Neue Gruppe anlegen");
print "<P><TABLE BGCOLOR=#c0c0c0 BORDER=1><TR BGCOLOR=#ff00ff><TH>Gruppenname</TH></TR>";

@gruppen = sort @gruppen;
foreach(@gruppen) {
  print "<TR><TD><A HREF=\"shgroupdata.cgi?groupname=$_\">$_</A></TD></TR>";
}
print "</TABLE>";
print html_extfooter(getfullver());
