#################################################
# logging.pl - Routine zum Loggen
# siehe auch config.pl
# config.pl sollte eingebunden sein, sonst funktionierts nicht.
#
# (C) Arbeitskreis Linux,
# siehe copyright.txt im Hauptordner
#
# WT_VK.4.10.20030811-AV.4.00.00000000

# Schreibt einen String in die Log-Datei, wenn Logging eingeschaltet ist.
sub webtools_log {
  my $logstr = $_[0];
  local($filename, $fullstr, @timeinfo);
  
  @timeinfo = localtime(time());
  if (($WT_LOGGING == 1)&&($WT_LOGFILE ne "")) {
    $fullstr = sprintf "%s@%02d:%02d:%02d;%d-%02d-%02d:%s\n",$ENV{'REMOTE_USER'},$timeinfo[2],$timeinfo[1],$timeinfo[0],$timeinfo[5]+1900,$timeinfo[4]+1,$timeinfo[3],$logstr;
    $filename = sprintf ">>%s",$WT_LOGFILE;
    if (open(LOGFILEHAND,$filename)) {
      print LOGFILEHAND $fullstr;
      close LOGFILEHAND;
    }
  }
}

# Ermittelt den logging-Mode fr Fehler oder veAktionen aus der modinfo.dat.
# Parameter1: =1 fr Fehler, =2 fr vollendete Aktionen
# Rckgabe: 1 wenn positiv, '' wenn negativ
sub logmode {
  my $saright = $_[0];
  local(@moddata);
  
  open (MODINFO, "<./modinfo.dat");
  @moddata = <MODINFO>;
  close(MODINFO);
  if (($saright == 2)&&($moddata[6]==1)) {return 1;}
  if (($saright == 1)&&($moddata[7]==1)) {return 1;}
  return '';
}
1; # --
