#################################################
# pwdup.pl
# Diese Datei aktualisiert das yfh.pwd - File
# anhand der Daten in /etc/shadow
#
# (C) Arbeitskreis Linux,
# siehe copyright.txt im Hauptordner
#
# WT_VK.4.10.20030811-AV.4.00.00000000

sub createpassdata {
  local(@passwdfile,@passwdteile,@htpass);
  
  open(PASSWD,'</etc/shadow');
  @passwdfile = <PASSWD>;
  close(PASSWD);
  foreach (@passwdfile) {
    chop;
    @passwdteile = split (/:/,$_,-1);
    if (($passwdteile[1] ne "*") && ($passwdteile[0] ne "root")) {
     push(@htpass, sprintf "%s:%s", $passwdteile[0], $passwdteile[1]);
    }
    undef(@passwdteile);
  }
  open(HPASSWD, ">$HTPASSFILE"); # HTPASSFILE siehe config.pl
  foreach(@htpass) {
    print HPASSWD $_,"\n";
  }
  close(HPASSWD);
  ($name,$passwd,$uid,$gid,$rest)=getpwnam("wwwrun");
  chown($uid, $gid, $HTPASSFILE);
  chmod(0600,$HTPASSFILE);
 }

1; # OK?